#!/usr/bin/ksh93
#############################################################
# Program:	mkAuthMap.cgi
#               Copyright 2006, All Rights Reserved
#
# Description:	Version 0.4	
#
# Author:	Dana French (dfrench@mtxia.com)
#		615.556.0456
#
# Date:		20061024
#
#############################################################
# DOCUMENT_ROOT comes from the web server shell environment
DOCUMENT_BASE="/kshAuth/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR="${SCRIPT_FILENAME%/*}"
SCRIPT_CGI="${SCRIPT_NAME%/*}"
FPATH="${SCRIPT_DIR}"
SEARCHTERM=""

parseVars
initializeDoc
displayHeader
defineLocations
linkbar CURRENTDIR DDDIR
defineStructInfo
displayStructInfo INFODES INFOVAL

################################################################

print -- "<P><FONT Size=\"+1\">

Display a map of the entire authorization structure for directory
administrators and users.

</FONT</P>
<P><HR></P>"

################################################################

print -- "<P><H2>Authorization Structure Map</H2></P>"
print -- "<P><BLOCKQUOTE>"

print -- "<P><H3>Directory Administrator Authorization Structure</H3></P>"
print -- "<P><BLOCKQUOTE>"

find ${BASEDIR} -name .diradmin -print | sort |
while read -r -- ADMFPFN
do
  DIRADMIN="${ADMFPFN#${DOCUMENT_ROOT}/..}"
  IFS=$'/'
  DIRS=( ${DIRADMIN%/*} )
  IFS=$' \t\n'

  SUMDIR=""
  for DIR in "${DIRS[@]}"
  do
    URLNAME="${DIR}"
    SUMDIR="${SUMDIR}/${DIR}"
    [[ "_/${DIR}/" == "_${DOCUMENT_BASE}" ]] && SUMDIR=""
    print -- "<A Href=\"/cgi-bin${DOCUMENT_BASE}utilities.cgi?DDDIR=${SUMDIR}\">${URLNAME}</A> / "
  done
  print -- "<BR>"

  SUMDIR=""
  for UNAME in $( sort -t":" +0 "${ADMFPFN}" | awk -F: '{ print $1 }' )
  do
    for DIR in "${DIRS[@]}"
    do
      URLNAME="${DIR}"
      SUMDIR="${SUMDIR}/${DIR}"
      [[ "_/${DIR}/" == "_${DOCUMENT_BASE}" ]] && SUMDIR=""
      print -- "<A Href=\"/cgi-bin${DOCUMENT_BASE}utilities.cgi?DDDIR=${SUMDIR}\">${URLNAME}</A> / "
    done
    print -- "${UNAME}<BR>"
  done
  print -- "<BR>"

done
print -- "</BLOCKQUOTE></P>"

################################################################

print -- "<P><H3>User Authorization Structure</H3></P>"
print -- "<P><BLOCKQUOTE>"

find ${BASEDIR} -name .htpasswd -print | sort |
while read -r -- USRFPFN
do
  HTPASSWD="${USRFPFN}"
  HTACCESS="${HTPASSWD#${DOCUMENT_ROOT}/..}"
  HTACCESS="${DOCUMENT_ROOT}${HTACCESS}"
  HTACCESS="${HTACCESS%/*}/.htaccess"

  if [[ -f "${HTACCESS}" ]] &&
     grep -i '^ *AuthUserFile' "${HTACCESS}" > /dev/null 2>&1
  then

    DIRHTACCESS="${HTPASSWD#${DOCUMENT_ROOT}/..}"
    IFS=$'/'
    DIRS=( ${DIRHTACCESS%/*} )
    IFS=$' \t\n'

    SUMDIR=""
    for DIR in "${DIRS[@]}"
    do
      URLNAME="${DIR}"
      SUMDIR="${SUMDIR}/${DIR}"
      [[ "_/${DIR}/" == "_${DOCUMENT_BASE}" ]] && SUMDIR=""
      print -- "<A Href=\"/cgi-bin${DOCUMENT_BASE}utilities.cgi?DDDIR=${SUMDIR}\">${URLNAME}</A> / "
    done
    print -- "<BR>"

    SUMDIR=""
    for UNAME in $( sort -t":" +0 "${USRFPFN}" | awk -F: '{ print $1 }' )
    do
      for DIR in "${DIRS[@]}"
      do
        URLNAME="${DIR}"
        SUMDIR="${SUMDIR}/${DIR}"
        [[ "_/${DIR}/" == "_${DOCUMENT_BASE}" ]] && SUMDIR=""
        print -- "<A Href=\"/cgi-bin${DOCUMENT_BASE}utilities.cgi?DDDIR=${SUMDIR}\">${URLNAME}</A> / "
      done
      print -- "${UNAME}<BR>"
    done
    print -- "<BR>"
  fi
done

print -- "</BLOCKQUOTE></P>"

print -- "</BLOCKQUOTE></P>"

################################################################

linkbar CURRENTDIR DDDIR
displayReadme
finalizeDoc

exit 0
