#!/usr/bin/ksh93
#############################################################
# Program:	rmAdminAuth.cgi
#               Copyright 2006, All Rights Reserved
#
# Description:	Version 0.4	
#
# Author:	Dana French (dfrench@mtxia.com)
#		615.556.0456
#
# Date:		20061024
#
#############################################################
# DOCUMENT_ROOT comes from the web server shell environment
DOCUMENT_BASE="/kshAuth/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR="${SCRIPT_FILENAME%/*}"
SCRIPT_CGI="${SCRIPT_NAME%/*}"
FPATH="${SCRIPT_DIR}"
SEARCHTERM=""

####  POST form: read from standard input
read -r -- QUERY_STRING

parseVars
initializeDoc
displayHeader
defineLocations

################################################################

BASEDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}"
PARPWDDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
PARPWDDIR="${PARPWDDIR%%+(/)}"
PARPWDDIR="${PARPWDDIR%/*}/"
PARPWDFILE=""
AUTHFILE=".diradmin"
findAuthFile BASEDIR PARPWDDIR PARPWDFILE AUTHFILE

################################################################

BASEDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}"
CHIPWDDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
CHIPWDFILE=""
AUTHFILE=".diradmin"
findAuthFile BASEDIR CHIPWDDIR CHIPWDFILE AUTHFILE

################################################################

linkbar CURRENTDIR DDDIR
defineStructInfo

INFODES[3]="Parent Administrator Authorization Structure:"
INFODES[4]="Child Administrator Authorization Structure:"
INFOVAL[3]="/${PARPWDDIR#${DOCUMENT_ROOT}/..${DOCUMENT_BASE}}"
INFOVAL[4]="/${CHIPWDDIR#${DOCUMENT_ROOT}/..${DOCUMENT_BASE}}"

displayStructInfo INFODES INFOVAL

################################################################

print -- "<P><FONT Size=\"+1\">

Removing directory administrator authorization structure. 

</FONT></P>
<P><HR></P>"

################################################################
####	First check the password protection parameters
################################################################

chkvalue "${ADM_USERID}"	"Directory Administrator ID"
chkvalue "${ADM_PASSWORD}"	"Directory Administrator Password"

################################################################
####	compare passwords
################################################################
EXITLEVEL="1"

ADMTMPFILE="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}rmAdminAuth${$}.tmp"
rm -f "${ADMTMPFILE}"
/usr/sbin/htpasswd2 -b -s -c "${ADMTMPFILE}" "${ADM_USERID}" "${ADM_PASSWORD}" >/dev/null 2>&1

if [[ -f "${ADMTMPFILE}" ]]
then
  chmod 600 "${ADMTMPFILE}"
  if grep "^${ADM_USERID}:" "${PARPWDFILE}" | head -1 | diff "${ADMTMPFILE}" - > /dev/null 2>&1
  then
    print -- "<BR>Directory Administrator <I>${ADM_USERID}</I> Verified.<BR>"
    EXITLEVEL="0"
  else
    print -- "<BR><STRONG>ERROR:</STRONG> Improper Directory Administrator ID or password.<BR>"
  fi
  rm -f "${ADMTMPFILE}"
else
  print -- "<BR><STRONG>ERROR:</STRONG> Unable to compare Directory Administrator login.<BR>"
fi

################################################################

if (( ${EXITLEVEL} == 0 ))
then
  if [[ "_${CHIPWDDIR}" == "_${DOCUMENT_ROOT}/..${DOCUMENT_BASE}" ]]
  then
    print -- "<P><STRONG>Removing the top level directory administrator authorization structure is not allowed.</STRONG></P>"
  else
    rm -f "${CHIPWDFILE}" > /dev/null 2>&1
    rm -f "${CHIPWDDIR}".AID_* > /dev/null 2>&1
    print -- "<P><STRONG>"
    print -- "Child Directory Administrator Authorization Structure has been removed.<BR>"
    print -- "</STRONG></P>"
  fi
fi
  
################################################################

linkbar CURRENTDIR DDDIR
displayReadme
finalizeDoc

exit 0
